// Item Bean

package auction;
import  java.sql.*;
import  java.util.*;
import  auction.*;

public class Item
{
    private  String name,description,closeson,catcode;
    private  int initprice;

    public  void setName(String name)
    { this.name = name; }

    public String getName()
    {  return name; }

    public  void setDescription(String description)
    { this.description= description; }

    public String geDescription()
    {  return description; }


    public  void setCloseson(String closeson)
	{ this.closeson= closeson; }

	public String getCloseson()
	{  return closeson; }


    public  void setInitprice(int initprice)
	{ this.initprice= initprice; }

	public int getInitprice()
	{  return initprice; }



    public  void setCatcode(String catcode)
    { this.catcode = catcode; }

    public String getCatcode()
    {  return catcode; }

    public static  String getCatname(String catcode)
    {
		  if ( catcode.equals("b") )
		     return "Books & Stationary ";
		  else
		   if ( catcode.equals("e") )
		     return "Electronics";
		   else
		     if ( catcode.equals("g") )
		      return "Garments";
		     else
		       return "Sports Goods";
    }

    public static String bidForItem(String buyer,int itemid, int bidprice)
    {

        Connection con = null;
        PreparedStatement ps = null;
        try
        {
         con = MemberBean.getConnection();
         con.setAutoCommit(false);
         ps = con.prepareStatement("insert into biddings values(?,?,?,sysdate)");
         ps.setInt(1,itemid);
         ps.setString(2,buyer);
         ps.setInt(3,bidprice);
         ps.executeUpdate();

         ps = con.prepareStatement("update items set highestbid = ? where itemid = ?");
         ps.setInt(1,bidprice);
         ps.setInt(2,itemid);
         ps.executeUpdate();

         con.commit();

         return null;
        }
        catch(Exception ex)
        {
	      try { con.rollback(); } catch (Exception nex) {}
   		  return ex.getMessage();
        }
        finally
        {
		 try
		 {  ps.close();
            con.close();
	     }
	     catch(Exception ex) {}
        }


    }

    public static boolean delete(String itemid)
    {
        // get access to  Object
        Connection con = null;
        CallableStatement cs = null;
        try
        {
         con = MemberBean.getConnection();
         cs = con.prepareCall("{call removeitem(?)}");
         cs.setString(1,itemid);
         cs.execute();
         return true;
        }
        catch(Exception ex)
        {
   		  System.out.println(ex.getMessage());
   		  return false;
        }
        finally
        {
		 try
		 {  cs.close();
            con.close();
	     }
	     catch(Exception ex) {}
        }

    } // end of delete()



    public int addItem(String uname)
    {

     // get access to User Object

     Connection con = null;
     PreparedStatement ps = null;
     try
     {
      con = MemberBean.getConnection();
      // get next itemid
      Statement st = con.createStatement();
      ResultSet rs = st.executeQuery("select nvl(max(itemid),0) + 1 from items");
      rs.next();
      int itemid = rs.getInt(1);
      rs.close();
      st.close();
      //insert question
      ps = con.prepareStatement("insert into items  values (?,?,?,?,?,sysdate,?,?,null)");
      ps.setInt(1,itemid);
      ps.setString(2,name);
      ps.setString(3,description);
      ps.setString(4,uname);
      ps.setInt(5,initprice);
      ps.setString(6,closeson);
      ps.setString(7,catcode);

      ps.executeQuery();
      return itemid;
      }
      catch(Exception ex)
      {
       System.out.println(ex.getMessage());
       return -1;
      }
      finally
      {
       try
       {
        if ( con != null) con.close();
       }
       catch(Exception ex) {}
      }

   } // end of addItem

} // end of bean








