package auction.ejb;

import java.io.Serializable;
import javax.ejb.*;
import javax.naming.*;
import javax.sql.DataSource;
import java.sql.*;


abstract public class MemberEJB implements EntityBean {
  private EntityContext ctx;
  public MemberEJB() {};

  public void setEntityContext(EntityContext ctx)
  {
    this.ctx = ctx;
  }

   public void unsetEntityContext() {
    this.ctx = null;
  }


	// container managed fields

 	abstract public String getUname();
	abstract public void setUname(String uname);

 	abstract public String getPwd();
	abstract public void setPwd(String pwd);

	abstract public String getEmail();
	abstract public void setEmail(String email);


    abstract public String getPhone();
	abstract public void setPhone(String phone);

	abstract public String getAddress();
	abstract public void setAddress(String address);

   public void ejbActivate() {  }
   public void ejbPassivate() { }
   public void ejbLoad() {}
   public void ejbStore() { }

   public void ejbRemove()throws RemoveException {}

   public String ejbCreate(String uname,String pwd, String email, String phone, String address) throws CreateException
   {
    setUname(uname);
    setPwd(pwd);
    setEmail(email);
    setPhone(phone);
    setAddress(address);

    return null;
   }

   public void ejbPostCreate(String uname,String pwd, String email, String phone, String address) throws CreateException {}

}
